﻿#ifndef TDEF_H_INCLUDED
#define TDEF_H_INCLUDED


/////////////////////////////////////////////////////////////////////////////
// 型,定数定義
/////////////////////////////////////////////////////////////////////////////
#if defined(_WIN32) || defined(_WIN64)
#define	NOMINMAX	1				// max,min無効化
#include <windows.h>
#else
using BYTE  = uint8_t;
using WORD  = uint16_t;
using DWORD = uint32_t;
#endif

#ifndef PATH_MAX
#define	PATH_MAX	260
#endif

/////////////////////////////////////////////////////////////////////////////
// 汎用マクロ
/////////////////////////////////////////////////////////////////////////////
#define	COUNTOF(arr)		(int)(sizeof(arr)/sizeof((arr)[0]))
#define INITARRAY(arr,val)	{for(int i=0; i<COUNTOF(arr); i++) arr[i] = val;}

#ifndef ZeroMemory
#define ZeroMemory(d,l)	memset((d), 0, (l))
#endif

// 32bit環境だとNOMINMAXが効かないみたい?
#undef max
#undef min

template <class T, class S> T max( T v1, S v2 ){ T v2_(v2); return v1 > v2_ ? v1 : v2_; }
template <class T, class S> T min( T v1, S v2 ){ T v2_(v2); return v1 < v2_ ? v1 : v2_; }


#endif
